//+------------------------------------------------------------------+
//|                                               Percent Trader.mq5 |
//|                                                   Charles Marley |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Charles Marley"
#property link      "https://www.mql5.com"
#property version   "1.00"

//---Include code
#include <Trade\Trade.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Expert\Expert.mqh>  

//---EA input variables
input string   Comment1;                  //Comment 1
input double   Percent1_Up;               //Percent 1 Bullish
input double   Percent1_Down;             //Percent 1 Bearish
input bool     Trade1 = false;            //Trade 1
input double   Lot1;                      //Lot 1
input double   TakeProfit1;               //Take Profit 1
input double   StopLoss1;                 //Stop Loss 1
input int      TrailingStop_inPoints1;      //Trailing stop 1 (points)
double set_TP1;
double set_SL1;

input string   Comment2;                  //Comment 2
input double   Percent2_Up;               //Percent 2 Bullish
input double   Percent2_Down;             //Percent 2 Bearish
input bool     Trade2 = false;            //Trade 2
input double   Lot2;                      //Lot 2
input double   TakeProfit2;               //Take Profit 2
input double   StopLoss2;                 //Stop Loss 2
input int      TrailingStop_inPoints2;      //Trailing stop 2 (points)
double set_TP2;
double set_SL2;

input string   Comment3;                  //Comment 3
input double   Percent3_Up;               //Percent 3 Bullish
input double   Percent3_Down;             //Percent 3 Bearish
input bool     Trade3 = false;            //Trade 3
input double   Lot3;                      //Lot 3
input double   TakeProfit3;               //Take Profit 3
input double   StopLoss3;                 //Stop Loss 3
input int      TrailingStop_inPoints3;      //Trailing stop 3 (points)
double set_TP3;
double set_SL3;

input string   Comment4;                  //Comment 4
input double   Percent4_Up;               //Percent 4 Bullish
input double   Percent4_Down;             //Percent 4 Bearish
input bool     Trade4 = false;            //Trade 4
input double   Lot4;                      //Lot 4
input double   TakeProfit4;               //Take Profit 4
input double   StopLoss4;                 //Stop Loss 4
input int      TrailingStop_inPoints4;      //Trailing stop 4 (points)
double set_TP4;
double set_SL4;


//---system info vaariables
CTrade myTradingControlPanel;
double current_market_change;
double currentBid, currentAsk;
int numpos;
CPositionInfo  m_position; 
double stopLossLevel1, takeProfitLevel1, stopLossLevel2, takeProfitLevel2, stopLossLevel3, takeProfitLevel3, stopLossLevel4, takeProfitLevel4;
int P;
CExpert m_trade;


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   EventSetTimer(60);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
   current_market_change=SymbolInfoDouble(_Symbol,SYMBOL_PRICE_CHANGE); //percentage change of price symbol
   currentBid = SymbolInfoDouble(_Symbol,SYMBOL_BID); // Get latest Bid Price
   currentAsk = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
//implement buy and sell conditions
   
//----Percent 1   
   
//   double Stop_Level1 = currentBid - StopLoss1;
//   double Take_pf_Level1 = currentBid + TakeProfit1;
    

//---Percent1 
    //---BUYYYYYYYYYY   
    if(Trade1 == true && current_market_change >= Percent1_Up && current_market_change > 0 && Percent1_Up > 0 && PositionSelect(_Symbol) == 0) 
    {
    set_TP1= currentAsk + (TakeProfit1 * _Point);
    set_SL1= currentAsk - (StopLoss1 * _Point);    
    myTradingControlPanel.PositionOpen(_Symbol, ORDER_TYPE_BUY, Lot1, currentAsk, set_SL1, set_TP1, Comment1); // Open a Buy position
    StopLevel(TrailingStop_inPoints1);    
    }
    
    
    //---SELLLLLLLLLL
    if(Trade1 == true && current_market_change <= Percent1_Down && current_market_change < 0 && Percent1_Down < 0 && PositionSelect(_Symbol) == 0) 
    {
    set_TP1= currentAsk - (TakeProfit1 * _Point);
    set_SL1= currentAsk + (StopLoss1 * _Point);   
    myTradingControlPanel.PositionOpen(_Symbol, ORDER_TYPE_SELL, Lot1, currentAsk, set_SL1, set_TP1, Comment1); // Open a Sell position
    StopLevel(TrailingStop_inPoints1);
    if(PositionSelect(_Symbol)==1 && m_position.PositionType()) 
    {
    Alert("Sell1 Trade openned on input %s", Percent1_Down);
    SendMail("Sell1 Trade", "Trade 1 (Sell2) has been openned");
    SendNotification("Sell2 Trade openned " );    
    }
    }
        

//---Percent 2 
    //---BUYYYYYYYYYY       
    if(Trade2 == true && current_market_change >= Percent2_Up && current_market_change > 0 && Percent2_Up > 0 && PositionSelect(_Symbol) >= 1) 
    {
    set_TP2= currentAsk + (TakeProfit2 * _Point);
    set_SL2= currentAsk - (StopLoss2 * _Point);    
    myTradingControlPanel.PositionOpen(_Symbol, ORDER_TYPE_BUY, Lot2, currentAsk, set_SL2, set_TP2, Comment2); // Open a Buy position
    StopLevel(TrailingStop_inPoints2);        
    if(POSITION_TYPE_BUY) 
    {
    Alert("Buy2 Trade openned ");
    SendMail("Buy2 Trade", "Trade 2 (Buy2) has been openned");
    SendNotification("Buy2 Trade openned " );    
    }
    }
    
    //---SELLLLLLLLLL
    if(Trade2 == true && current_market_change <= Percent2_Down && current_market_change < 0 && Percent2_Down < 0 && PositionSelect(_Symbol) >= 1) 
    {
    set_TP2= currentAsk - (TakeProfit2 * _Point);
    set_SL2= currentAsk + (StopLoss2 * _Point);    
    myTradingControlPanel.PositionOpen(_Symbol, ORDER_TYPE_SELL, Lot2, currentAsk, set_SL2, set_TP2, Comment2); // Open a Sell position
    StopLevel(TrailingStop_inPoints2);        
    Alert("Sell2 Trade openned");
    SendMail("Sell2 Trade", "Trade 2 (Sell2) has been openned");
    SendNotification("Sell2 Trade openned");    
    }    
 
 //---Percent 3
    //---BUYYYYYYYYYY
    if(Trade3 == true && current_market_change >= Percent3_Up && current_market_change > 0 && Percent3_Up > 0 && PositionSelect(_Symbol) >= 2) 
    {
    set_TP3= currentAsk + (TakeProfit3 * _Point);
    set_SL3= currentAsk - (StopLoss3 * _Point);    
    myTradingControlPanel.PositionOpen(_Symbol, ORDER_TYPE_BUY, Lot3, currentAsk, set_SL3, set_TP3, Comment3); // Open a Buy position
    StopLevel(TrailingStop_inPoints3);        
    Alert("Buy3 Trade openned");
    SendMail("Buy3 Trade", "Trade 3 (Buy3) has been openned");
    SendNotification("Buy3 Trade openned " );    
    }
    //---SELLLLLLLLLL
    if(Trade3 == true && current_market_change <= Percent3_Down && current_market_change < 0 && Percent3_Down < 0 && PositionSelect(_Symbol) >= 2) 
    {
    set_TP3= currentAsk - (TakeProfit3 * _Point);
    set_SL3= currentAsk + (StopLoss3 * _Point);    
    myTradingControlPanel.PositionOpen(_Symbol, ORDER_TYPE_SELL, Lot3, currentAsk, set_SL3, set_TP3, Comment3); // Open a Sell position
    StopLevel(TrailingStop_inPoints3);        
    Alert("Sell3 Trade openned");
    SendMail("Sell3 Trade", "Trade 3 (Sell3) has been openned");
    SendNotification("Sell3 Trade openned");    
    } 

//---Percent4
    //---BUYYYYYYYYYY
    if(Trade4 == true && current_market_change >= Percent4_Up && current_market_change > 0 && Percent4_Up > 0 && PositionSelect(_Symbol) >= 3) 
    {
    set_TP4= currentAsk + (TakeProfit4 * _Point);
    set_SL4= currentAsk - (StopLoss4 * _Point);    
    myTradingControlPanel.PositionOpen(_Symbol, ORDER_TYPE_BUY, Lot4, currentAsk, set_SL4, set_TP4, Comment4); // Open a Buy position
    StopLevel(TrailingStop_inPoints4); 
    Alert("Buy4 Trade openned");
    SendMail("Buy4 Trade", "Trade 4 (Buy4) has been openned");
    SendNotification("Buy4 Trade openned " );    

    }
    //---SELLLLLLLLLL
    if(Trade4 == true && current_market_change <= Percent4_Down && current_market_change < 0 && Percent4_Down < 0 && PositionSelect(_Symbol) >= 3) 
    {
    set_TP4= currentAsk - (TakeProfit4 * _Point);
    set_SL4= currentAsk + (StopLoss4 * _Point);    
    myTradingControlPanel.PositionOpen(_Symbol, ORDER_TYPE_SELL, Lot4, currentAsk, set_SL4, set_TP4, Comment4); // Open a Sell position
    StopLevel(TrailingStop_inPoints4);
    Alert("Sell4 Trade openned");
    SendMail("Sell4 Trade", "Trade 4 (Sell4) has been openned");
    SendNotification("Sell4 Trade openned");      
    }      
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
//--- custom criterion optimization value (the higher, the better)
   double ret=0.0;


//---
   return(ret);
  }
//+------------------------------------------------------------------+
//| TesterInit function                                              |
//+------------------------------------------------------------------+
void OnTesterInit()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterPass function                                              |
//+------------------------------------------------------------------+
void OnTesterPass()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| TesterDeinit function                                            |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
//---
   
  }
/*
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
*/  
/*
//+------------------------------------------------------------------+
//| BookEvent function                                               |
//+------------------------------------------------------------------+
void OnBookEvent(const string &symbol)
  {
//---
   
  }
//+------------------------------------------------------------------+
*/ 
  
void  ProfitLevel(int  profit_level);
void  StopLevel(int  stop_level){};

void OnTrade() 
   {
   ulong ticket;
   ulong type_of_order;
   double open_price;
   string commodity;
   double pos_tp;
   double pos_sl;
   
   ticket = myTradingControlPanel.RequestPosition();
   type_of_order = myTradingControlPanel.RequestOrder();
   open_price = myTradingControlPanel.RequestPrice();
   commodity = myTradingControlPanel.RequestSymbol();
   pos_tp = myTradingControlPanel.RequestTP();
   pos_sl = myTradingControlPanel.RequestSL();
   
   
   if(OrderSelect(ticket)
  // Alert("Position openned %s", ticket)
   }


/*
    if(PositionSelectByTicket ) 
    {
    Alert("Buy1 Trade openned on input %s", Percent1_Up);
    SendMail("Buy1 Trade", "Trade 1 (Buy1) has been openned");
    SendNotification("Buy1 Trade openned " ); 
    */
    
/*    
void SendTradeEmail(int ticket)
{
   if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
      {
         string MsgSubject = OrderSymbol() + " ";
         string MsgBody = "Pair Traded: "+OrderSymbol();
         MsgBody = MsgBody + "nBuy Or Sell: ";
         if (OrderType() == OP_BUY)
         {
            MsgSubject = MsgSubject + "BUY ";
            MsgBody = MsgBody + "BUY";
         }
         if (OrderType() == OP_SELL)
         {
            MsgSubject = MsgSubject + "SELL ";
            MsgBody = MsgBody + "SELL";
         }
         MsgBody = MsgBody + "nTime: "+TimeToStr(OrderOpenTime(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
         MsgSubject = MsgSubject + DoubleToStr(OrderOpenPrice(),Digits);
         MsgBody = MsgBody + "nOpen Price: "+DoubleToStr(OrderOpenPrice(),Digits);
         MsgBody = MsgBody + "nLot Size: "+DoubleToStr(OrderLots(),3);
      
         SendMail(MsgSubject,MsgBody);
      }
   }
}

*/